Index: serefpolicy-contrib-20140730/cron.if
===================================================================
--- serefpolicy-contrib-20140730.orig/cron.if
+++ serefpolicy-contrib-20140730/cron.if
@@ -2,11 +2,12 @@
 
 #######################################
 ## <summary>
-##	The template to define a crontab domain.
+##	The common rules for a crontab domain.
 ## </summary>
-## <param name="domain_prefix">
+## <param name="userdomain_prefix">
 ##	<summary>
-##	Domain prefix to be used.
+##	The prefix of the user domain (e.g., user
+##	is the prefix for user_t).
 ##	</summary>
 ## </param>
 #
@@ -36,22 +37,29 @@ template(`cron_common_crontab_template',
 	manage_files_pattern($1_t, $1_tmp_t, $1_tmp_t)
 	files_tmp_filetrans($1_t, $1_tmp_t, { dir file })
 
+	kernel_read_system_state($1_t)
+
 	auth_domtrans_chk_passwd($1_t)
 	auth_use_nsswitch($1_t)
+
+	logging_send_syslog_msg($1_t)
+
+	userdom_home_reader($1_t)
+
 ')
 
 ########################################
 ## <summary>
-##	Role access for cron.
+##	Role access for cron
 ## </summary>
 ## <param name="role">
 ##	<summary>
-##	Role allowed access.
+##	Role allowed access
 ##	</summary>
 ## </param>
 ## <param name="domain">
 ##	<summary>
-##	User domain for the role.
+##	User domain for the role
 ##	</summary>
 ## </param>
 ## <rolecap/>
@@ -60,56 +68,66 @@ interface(`cron_role',`
 	gen_require(`
 		type cronjob_t, crontab_t, crontab_exec_t;
 		type user_cron_spool_t, crond_t;
-		bool cron_userdomain_transition;
+        bool cron_userdomain_transition;
 	')
 
-	##############################
-	#
-	# Declarations
-	#
+    ##############################
+    #
+    # Declarations
+    #
 
 	role $1 types { cronjob_t crontab_t };
 
-	##############################
-	#
-	# Local policy
-	#
+    ##############################
+    #
+    # Local policy
+    #
 
+	# Transition from the user domain to the derived domain.
 	domtrans_pattern($2, crontab_exec_t, crontab_t)
 
 	dontaudit crond_t $2:process { noatsecure siginh rlimitinh };
 	allow $2 crond_t:process sigchld;
 
-	allow $2 user_cron_spool_t:file { getattr read write ioctl };
+    allow $2 user_cron_spool_t:file { getattr read write ioctl };
 
-	allow $2 crontab_t:process { ptrace signal_perms };
+	# crontab shows up in user ps
+	allow $2 crontab_t:process signal_perms;
 	ps_process_pattern($2, crontab_t)
 
+	tunable_policy(`deny_ptrace',`',`
+		allow $2 crontab_t:process ptrace;
+	')
+
+	# Run helper programs as the user domain
+	#corecmd_bin_domtrans(crontab_t, $2)
+	#corecmd_shell_domtrans(crontab_t, $2)
 	corecmd_exec_bin(crontab_t)
 	corecmd_exec_shell(crontab_t)
 
-	tunable_policy(`cron_userdomain_transition',`
-		allow crond_t $2:process transition;
-		allow crond_t $2:fd use;
-		allow crond_t $2:key manage_key_perms;
+    tunable_policy(`cron_userdomain_transition',`
+        allow crond_t $2:process transition;
+        allow crond_t $2:fd use;
+        allow crond_t $2:key manage_key_perms;
 
-		allow $2 user_cron_spool_t:file entrypoint;
+	    # needs to be authorized SELinux context for cron
+	    allow $2 user_cron_spool_t:file entrypoint;
+        allow $2 crond_t:fifo_file rw_fifo_file_perms;
 
-		allow $2 crond_t:fifo_file rw_fifo_file_perms;
+        allow $2 cronjob_t:process { signal_perms };
 
-		allow $2 cronjob_t:process { ptrace signal_perms };
-		ps_process_pattern($2, cronjob_t)
-	',`
-		dontaudit crond_t $2:process transition;
-		dontaudit crond_t $2:fd use;
-		dontaudit crond_t $2:key manage_key_perms;
+        ps_process_pattern($2, cronjob_t)
+    ',`
+        dontaudit crond_t $2:process transition;
+        dontaudit crond_t $2:fd use;
+        dontaudit crond_t $2:key manage_key_perms;
 
-		dontaudit $2 user_cron_spool_t:file entrypoint;
+        dontaudit $2 user_cron_spool_t:file entrypoint;
 
-		dontaudit $2 crond_t:fifo_file rw_fifo_file_perms;
+        dontaudit $2 crond_t:fifo_file rw_fifo_file_perms;
 
-		dontaudit $2 cronjob_t:process { ptrace signal_perms };
-	')
+        dontaudit $2 cronjob_t:process { signal_perms };
+    ')
 
 	optional_policy(`
 		gen_require(`
@@ -119,78 +137,87 @@ interface(`cron_role',`
 		dbus_stub(cronjob_t)
 
 		allow cronjob_t $2:dbus send_msg;
-	')
+	')		
 ')
 
 ########################################
 ## <summary>
-##	Role access for unconfined cron.
+##	Role access for unconfined cronjobs
 ## </summary>
 ## <param name="role">
 ##	<summary>
-##	Role allowed access.
+##	Role allowed access
 ##	</summary>
 ## </param>
 ## <param name="domain">
 ##	<summary>
-##	User domain for the role.
+##	User domain for the role
 ##	</summary>
 ## </param>
+## <rolecap/>
 #
 interface(`cron_unconfined_role',`
 	gen_require(`
 		type unconfined_cronjob_t, crontab_t, crontab_exec_t;
-		type crond_t, user_cron_spool_t;
-		bool cron_userdomain_transition;
+        type crond_t, user_cron_spool_t;
+        bool cron_userdomain_transition;
 	')
 
-	##############################
-	#
-	# Declarations
-	#
+    ##############################
+    #
+    # Declarations
+    #
+    
+    role $1 types { unconfined_cronjob_t crontab_t };
 
-	role $1 types { unconfined_cronjob_t crontab_t };
+    ##############################
+    #
+    # Local policy
+    #
 
-	##############################
-	#
-	# Local policy
-	#
+    domtrans_pattern($2, crontab_exec_t, crontab_t)
 
-	domtrans_pattern($2, crontab_exec_t, crontab_t)
+    dontaudit crond_t $2:process { noatsecure siginh rlimitinh };
 
-	dontaudit crond_t $2:process { noatsecure siginh rlimitinh };
-	allow $2 crond_t:process sigchld;
+    allow $2 crond_t:process sigchld;
 
-	allow $2 user_cron_spool_t:file { getattr read write ioctl };
+    allow $2 user_cron_spool_t:file { getattr read write ioctl };
 
-	allow $2 crontab_t:process { ptrace signal_perms };
-	ps_process_pattern($2, crontab_t)
+    allow $2 crontab_t:process { signal_perms };
+    ps_process_pattern($2, crontab_t)
 
-	corecmd_exec_bin(crontab_t)
-	corecmd_exec_shell(crontab_t)
+	tunable_policy(`deny_ptrace',`',`
+        allow $2 crontab_t:process ptrace;
+    ')
 
-	tunable_policy(`cron_userdomain_transition',`
-		allow crond_t $2:process transition;
-		allow crond_t $2:fd use;
-		allow crond_t $2:key manage_key_perms;
+	# cronjob shows up in user ps
+	ps_process_pattern($2, unconfined_cronjob_t)
+	allow $2 unconfined_cronjob_t:process signal_perms;
 
-		allow $2 user_cron_spool_t:file entrypoint;
+	tunable_policy(`deny_ptrace',`',`
+		allow $2 unconfined_cronjob_t:process ptrace;
+	')
 
-		allow $2 crond_t:fifo_file rw_fifo_file_perms;
+    corecmd_exec_bin(crontab_t)
+    corecmd_exec_shell(crontab_t)
 
-		allow $2 unconfined_cronjob_t:process { ptrace signal_perms };
-		ps_process_pattern($2, unconfined_cronjob_t)
-	',`
-		dontaudit crond_t $2:process transition;
-		dontaudit crond_t $2:fd use;
-		dontaudit crond_t $2:key manage_key_perms;
+    tunable_policy(`cron_userdomain_transition',`
+        allow crond_t $2:process transition;
+        allow crond_t $2:fd use;
+        allow crond_t $2:key manage_key_perms;
 
-		dontaudit $2 user_cron_spool_t:file entrypoint;
+        allow $2 user_cron_spool_t:file entrypoint;
 
-		dontaudit $2 crond_t:fifo_file rw_fifo_file_perms;
+        allow $2 crond_t:fifo_file rw_fifo_file_perms;
+    ',`
+        dontaudit crond_t $2:process transition;
+        dontaudit crond_t $2:fd use;
+        dontaudit crond_t $2:key manage_key_perms;
 
-		dontaudit $2 unconfined_cronjob_t:process { ptrace signal_perms };
-')
+        dontaudit $2 user_cron_spool_t:file entrypoint;
+
+        dontaudit $2 crond_t:fifo_file rw_fifo_file_perms;
+    ')
 
 	optional_policy(`
 		gen_require(`
@@ -198,55 +225,60 @@ interface(`cron_unconfined_role',`
 		')
 
 		dbus_stub(unconfined_cronjob_t)
-
 		allow unconfined_cronjob_t $2:dbus send_msg;
 	')
 ')
 
 ########################################
 ## <summary>
-##	Role access for admin cron.
+##	Role access for cron
 ## </summary>
 ## <param name="role">
 ##	<summary>
-##	Role allowed access.
+##	Role allowed access
 ##	</summary>
 ## </param>
 ## <param name="domain">
 ##	<summary>
-##	User domain for the role.
+##	User domain for the role
 ##	</summary>
 ## </param>
+## <rolecap/>
 #
 interface(`cron_admin_role',`
 	gen_require(`
-		type cronjob_t, crontab_exec_t, admin_crontab_t;
+		type cronjob_t, crontab_exec_t, admin_crontab_t, admin_crontab_tmp_t;
+		type user_cron_spool_t, crond_t;
 		class passwd crontab;
-		type crond_t, crond_var_run_t, user_cron_spool_t;
-		bool cron_userdomain_transition;
+        bool cron_userdomain_transition;
 	')
 
-	##############################
-	#
-	# Declarations
-	#
+    ##############################
+    #
+    # Declarations
+    #
 
-	role $1 types { cronjob_t admin_crontab_t };
+	role $1 types { cronjob_t admin_crontab_t admin_crontab_tmp_t };
 
-	##############################
-	#
-	# Local policy
-	#
+    ##############################
+    #
+    # Local policy
+    #
 
+	# Transition from the user domain to the derived domain.
 	domtrans_pattern($2, crontab_exec_t, admin_crontab_t)
 
 	dontaudit crond_t $2:process { noatsecure siginh rlimitinh };
-	allow $2 crond_t:process sigchld;
 
-	allow $2 user_cron_spool_t:file { getattr read write ioctl };
+	allow $2 crond_t:process sigchld;
 
-	allow $2 admin_crontab_t:process { ptrace signal_perms };
+	# crontab shows up in user ps
 	ps_process_pattern($2, admin_crontab_t)
+	allow $2 admin_crontab_t:process signal_perms;
+
+	tunable_policy(`deny_ptrace',`',`
+		allow $2 admin_crontab_t:process ptrace;
+	')
 
 	# Manipulate other users crontab.
 	allow $2 self:passwd crontab;
@@ -254,33 +286,26 @@ interface(`cron_admin_role',`
 	corecmd_exec_bin(admin_crontab_t)
 	corecmd_exec_shell(admin_crontab_t)
 
-	tunable_policy(`cron_userdomain_transition',`
-		allow crond_t $2:process transition;
-		allow crond_t $2:fd use;
-		allow crond_t $2:key manage_key_perms;
-
-		allow $2 user_cron_spool_t:file entrypoint;
-
-		allow $2 crond_t:fifo_file rw_fifo_file_perms;
-
-		allow $2 cronjob_t:process { ptrace signal_perms };
-		ps_process_pattern($2, cronjob_t)
-	',`
-		dontaudit crond_t $2:process transition;
-		dontaudit crond_t $2:fd use;
-		dontaudit crond_t $2:key manage_key_perms;
-
-		dontaudit $2 user_cron_spool_t:file entrypoint;
-
-		dontaudit $2 crond_t:fifo_file rw_fifo_file_perms;
-
-		dontaudit $2 cronjob_t:process { ptrace signal_perms };
-	')
-
-	tunable_policy(`crond_fcron',`
-		# Support for fcrondyn
-		stream_connect_pattern($2, crond_var_run_t, crond_var_run_t, crond_t)
-	')
+    tunable_policy(`cron_userdomain_transition',`
+        allow crond_t $2:process transition;
+        allow crond_t $2:fd use;
+        allow crond_t $2:key manage_key_perms;
+
+        allow $2 user_cron_spool_t:file entrypoint;
+
+        allow $2 crond_t:fifo_file rw_fifo_file_perms;
+
+        allow $2 cronjob_t:process { signal_perms };
+        ps_process_pattern($2, cronjob_t)
+    ',`
+        dontaudit crond_t $2:process transition;
+        dontaudit crond_t $2:fd use;
+        dontaudit crond_t $2:key manage_key_perms;
+
+        dontaudit $2 user_cron_spool_t:file entrypoint;
+        dontaudit $2 crond_t:fifo_file rw_fifo_file_perms;
+        dontaudit $2 cronjob_t:process { signal_perms };
+    ')
 
 	optional_policy(`
 		gen_require(`
@@ -290,13 +315,13 @@ interface(`cron_admin_role',`
 		dbus_stub(admin_cronjob_t)
 
 		allow cronjob_t $2:dbus send_msg;
-	')
+	')		
 ')
 
 ########################################
 ## <summary>
-##	Make the specified program domain
-##	accessable from the system cron jobs.
+##	Make the specified program domain accessable
+##	from the system cron jobs.
 ## </summary>
 ## <param name="domain">
 ##	<summary>
@@ -312,15 +337,15 @@ interface(`cron_admin_role',`
 interface(`cron_system_entry',`
 	gen_require(`
 		type crond_t, system_cronjob_t;
-		type user_cron_spool_log_t;
 	')
 
-	rw_files_pattern($1, user_cron_spool_log_t, user_cron_spool_log_t)
-
 	domtrans_pattern(system_cronjob_t, $2, $1)
 	domtrans_pattern(crond_t, $2, $1)
 
 	role system_r types $1;
+
+	allow $1 crond_t:fifo_file rw_fifo_file_perms;
+	allow $1 system_cronjob_t:fifo_file rw_fifo_file_perms;
 ')
 
 ########################################
@@ -338,13 +363,12 @@ interface(`cron_domtrans',`
 		type system_cronjob_t, crond_exec_t;
 	')
 
-	corecmd_search_bin($1)
 	domtrans_pattern($1, crond_exec_t, system_cronjob_t)
 ')
 
 ########################################
 ## <summary>
-##	Execute crond in the caller domain. 
+##	Execute crond_exec_t 
 ## </summary>
 ## <param name="domain">
 ##	<summary>
@@ -357,7 +381,6 @@ interface(`cron_exec',`
 		type crond_exec_t;
 	')
 
-	corecmd_search_bin($1)
 	can_exec($1, crond_exec_t)
 ')
 
@@ -381,7 +404,31 @@ interface(`cron_initrc_domtrans',`
 
 ########################################
 ## <summary>
-##	Use crond file descriptors.
+##	Execute crond server in the crond domain.
+## </summary>
+## <param name="domain">
+##	<summary>
+##	Domain allowed to transition.
+##	</summary>
+## </param>
+#
+interface(`cron_systemctl',`
+	gen_require(`
+		type crond_unit_file_t;
+		type crond_t;
+	')
+
+	systemd_exec_systemctl($1)
+	allow $1 crond_unit_file_t:file read_file_perms;
+	allow $1 crond_unit_file_t:service manage_service_perms;
+
+	ps_process_pattern($1, crond_t)
+')
+
+########################################
+## <summary>
+##	Inherit and use a file descriptor
+##	from the cron daemon.
 ## </summary>
 ## <param name="domain">
 ##	<summary>
@@ -399,7 +446,7 @@ interface(`cron_use_fds',`
 
 ########################################
 ## <summary>
-##	Send child terminated signals to crond.
+##	Send a SIGCHLD signal to the cron daemon.
 ## </summary>
 ## <param name="domain">
 ##	<summary>
@@ -417,7 +464,7 @@ interface(`cron_sigchld',`
 
 ########################################
 ## <summary>
-##	Set the attributes of cron log files.
+##	Send a generic signal to cron daemon.
 ## </summary>
 ## <param name="domain">
 ##	<summary>
@@ -425,17 +472,17 @@ interface(`cron_sigchld',`
 ##	</summary>
 ## </param>
 #
-interface(`cron_setattr_log_files',`
+interface(`cron_signal',`
 	gen_require(`
-		type cron_log_t;
+		type crond_t;
 	')
 
-	allow $1 cron_log_t:file setattr_file_perms;
+	allow $1 crond_t:process signal;
 ')
 
 ########################################
 ## <summary>
-##	Create cron log files.
+##	Read a cron daemon unnamed pipe.
 ## </summary>
 ## <param name="domain">
 ##	<summary>
@@ -443,17 +490,17 @@ interface(`cron_setattr_log_files',`
 ##	</summary>
 ## </param>
 #
-interface(`cron_create_log_files',`
+interface(`cron_read_pipes',`
 	gen_require(`
-		type cron_log_t;
+		type crond_t;
 	')
 
-	create_files_pattern($1, cron_log_t, cron_log_t)
+	allow $1 crond_t:fifo_file read_fifo_file_perms;
 ')
 
 ########################################
 ## <summary>
-##	Write to cron log files.
+##	Read crond state files.
 ## </summary>
 ## <param name="domain">
 ##	<summary>
@@ -461,18 +508,20 @@ interface(`cron_create_log_files',`
 ##	</summary>
 ## </param>
 #
-interface(`cron_write_log_files',`
+interface(`cron_read_state_crond',`
 	gen_require(`
-		type cron_log_t;
+		type crond_t;
 	')
 
-	allow $1 cron_log_t:file write_file_perms;
+	kernel_search_proc($1)
+	ps_process_pattern($1, crond_t)
 ')
 
+
 ########################################
 ## <summary>
-##	Create, read, write and delete
-##	cron log files.
+##	Send and receive messages from
+##	crond over dbus.
 ## </summary>
 ## <param name="domain">
 ##	<summary>
@@ -480,48 +529,37 @@ interface(`cron_write_log_files',`
 ##	</summary>
 ## </param>
 #
-interface(`cron_manage_log_files',`
+interface(`cron_dbus_chat_crond',`
 	gen_require(`
-		type cron_log_t;
+		type crond_t;
+		class dbus send_msg;
 	')
 
-	manage_files_pattern($1, cron_log_t, cron_log_t)
-
-	logging_search_logs($1)
+	allow $1 crond_t:dbus send_msg;
+	allow crond_t $1:dbus send_msg;
 ')
 
 ########################################
 ## <summary>
-##	Create specified objects in generic
-##	log directories with the cron log file type.
+##	Do not audit attempts to write cron daemon unnamed pipes.
 ## </summary>
 ## <param name="domain">
 ##	<summary>
-##	Domain allowed access.
-##	</summary>
-## </param>
-## <param name="object_class">
-##	<summary>
-##	Class of the object being created.
-##	</summary>
-## </param>
-## <param name="name" optional="true">
-##	<summary>
-##	The name of the object being created.
+##	Domain to not audit.
 ##	</summary>
 ## </param>
 #
-interface(`cron_generic_log_filetrans_log',`
+interface(`cron_dontaudit_write_pipes',`
 	gen_require(`
-		type cron_log_t;
+		type crond_t;
 	')
 
-	logging_log_filetrans($1, cron_log_t, $2, $3)
+	dontaudit $1 crond_t:fifo_file write;
 ')
 
 ########################################
 ## <summary>
-##	Read cron daemon unnamed pipes.
+##	Read and write a cron daemon unnamed pipe.
 ## </summary>
 ## <param name="domain">
 ##	<summary>
@@ -529,36 +567,35 @@ interface(`cron_generic_log_filetrans_lo
 ##	</summary>
 ## </param>
 #
-interface(`cron_read_pipes',`
+interface(`cron_rw_pipes',`
 	gen_require(`
 		type crond_t;
 	')
 
-	allow $1 crond_t:fifo_file read_fifo_file_perms;
+	allow $1 crond_t:fifo_file rw_inherited_fifo_file_perms;
 ')
 
 ########################################
 ## <summary>
-##	Do not audit attempts to write
-##	cron daemon unnamed pipes.
+##	Read and write inherited user spool files.
 ## </summary>
 ## <param name="domain">
 ##	<summary>
-##	Domain to not audit.
+##	Domain allowed access.
 ##	</summary>
 ## </param>
 #
-interface(`cron_dontaudit_write_pipes',`
+interface(`cron_rw_inherited_user_spool_files',`
 	gen_require(`
-		type crond_t;
+		type user_cron_spool_t;
 	')
 
-	dontaudit $1 crond_t:fifo_file write;
+	allow $1 user_cron_spool_t:file rw_inherited_file_perms;
 ')
 
 ########################################
 ## <summary>
-##	Read and write crond unnamed pipes.
+##	Read and write inherited spool files.
 ## </summary>
 ## <param name="domain">
 ##	<summary>
@@ -566,17 +603,17 @@ interface(`cron_dontaudit_write_pipes',`
 ##	</summary>
 ## </param>
 #
-interface(`cron_rw_pipes',`
+interface(`cron_rw_inherited_spool_files',`
 	gen_require(`
-		type crond_t;
+		type cron_spool_t;
 	')
 
-	allow $1 crond_t:fifo_file rw_fifo_file_perms;
+	allow $1 cron_spool_t:file rw_inherited_file_perms;
 ')
 
 ########################################
 ## <summary>
-##	Read and write crond TCP sockets.
+##	Read, and write cron daemon TCP sockets.
 ## </summary>
 ## <param name="domain">
 ##	<summary>
@@ -594,8 +631,7 @@ interface(`cron_rw_tcp_sockets',`
 
 ########################################
 ## <summary>
-##	Do not audit attempts to read and
-##	write cron daemon TCP sockets.
+##	Dontaudit Read, and write cron daemon TCP sockets.
 ## </summary>
 ## <param name="domain">
 ##	<summary>
@@ -613,7 +649,7 @@ interface(`cron_dontaudit_rw_tcp_sockets
 
 ########################################
 ## <summary>
-##	Search cron spool directories.
+##	Search the directory containing user cron tables.
 ## </summary>
 ## <param name="domain">
 ##	<summary>
@@ -632,8 +668,26 @@ interface(`cron_search_spool',`
 
 ########################################
 ## <summary>
-##	Create, read, write, and delete
-##	crond pid files.
+##	Search the directory containing user cron tables.
+## </summary>
+## <param name="domain">
+##	<summary>
+##	Domain allowed access.
+##	</summary>
+## </param>
+#
+interface(`cron_manage_system_spool',`
+	gen_require(`
+		type cron_system_spool_t;
+	')
+
+	files_search_spool($1)
+	manage_files_pattern($1, cron_system_spool_t, cron_system_spool_t)
+')
+
+########################################
+## <summary>
+##	Manage pid files used by cron
 ## </summary>
 ## <param name="domain">
 ##	<summary>
@@ -646,13 +700,13 @@ interface(`cron_manage_pid_files',`
 		type crond_var_run_t;
 	')
 
+	files_search_pids($1)
 	manage_files_pattern($1, crond_var_run_t, crond_var_run_t)
 ')
 
 ########################################
 ## <summary>
-##	Execute anacron in the cron
-##	system domain.
+##	Execute anacron in the cron system domain.
 ## </summary>
 ## <param name="domain">
 ##	<summary>
@@ -665,13 +719,13 @@ interface(`cron_anacron_domtrans_system_
 		type system_cronjob_t, anacron_exec_t;
 	')
 
-	corecmd_search_bin($1)
 	domtrans_pattern($1, anacron_exec_t, system_cronjob_t)
 ')
 
 ########################################
 ## <summary>
-##	Use system cron job file descriptors.
+##	Inherit and use a file descriptor
+##	from system cron jobs.
 ## </summary>
 ## <param name="domain">
 ##	<summary>
@@ -689,7 +743,7 @@ interface(`cron_use_system_job_fds',`
 
 ########################################
 ## <summary>
-##	Read system cron job lib files.
+##	Write a system cron job unnamed pipe.
 ## </summary>
 ## <param name="domain">
 ##	<summary>
@@ -697,19 +751,17 @@ interface(`cron_use_system_job_fds',`
 ##	</summary>
 ## </param>
 #
-interface(`cron_read_system_job_lib_files',`
+interface(`cron_write_system_job_pipes',`
 	gen_require(`
-		type system_cronjob_var_lib_t;
+		type system_cronjob_t;
 	')
 
-	files_search_var_lib($1)
-	read_files_pattern($1, system_cronjob_var_lib_t, system_cronjob_var_lib_t)
+	allow $1 system_cronjob_t:fifo_file write;
 ')
 
 ########################################
 ## <summary>
-##	Create, read, write, and delete
-##	system cron job lib files.
+##	Read and write a system cron job unnamed pipe.
 ## </summary>
 ## <param name="domain">
 ##	<summary>
@@ -717,18 +769,17 @@ interface(`cron_read_system_job_lib_file
 ##	</summary>
 ## </param>
 #
-interface(`cron_manage_system_job_lib_files',`
+interface(`cron_rw_system_job_pipes',`
 	gen_require(`
-		type system_cronjob_var_lib_t;
+		type system_cronjob_t;
 	')
 
-	files_search_var_lib($1)
-	manage_files_pattern($1, system_cronjob_var_lib_t, system_cronjob_var_lib_t)
+	allow $1 system_cronjob_t:fifo_file rw_inherited_fifo_file_perms;
 ')
 
 ########################################
 ## <summary>
-##	Write system cron job unnamed pipes.
+##	Allow read/write unix stream sockets from the system cron jobs.
 ## </summary>
 ## <param name="domain">
 ##	<summary>
@@ -736,18 +787,17 @@ interface(`cron_manage_system_job_lib_fi
 ##	</summary>
 ## </param>
 #
-interface(`cron_write_system_job_pipes',`
+interface(`cron_rw_system_job_stream_sockets',`
 	gen_require(`
 		type system_cronjob_t;
 	')
 
-	allow $1 system_cronjob_t:file write;
+	allow $1 system_cronjob_t:unix_stream_socket { read write };
 ')
 
 ########################################
 ## <summary>
-##	Read and write system cron job
-##	unnamed pipes.
+##	Read temporary files from the system cron jobs.
 ## </summary>
 ## <param name="domain">
 ##	<summary>
@@ -755,86 +805,142 @@ interface(`cron_write_system_job_pipes',
 ##	</summary>
 ## </param>
 #
-interface(`cron_rw_system_job_pipes',`
+interface(`cron_read_system_job_tmp_files',`
 	gen_require(`
-		type system_cronjob_t;
+		type system_cronjob_tmp_t, cron_var_run_t;
 	')
 
-	allow $1 system_cronjob_t:fifo_file rw_fifo_file_perms;
+	files_search_tmp($1)
+	allow $1 system_cronjob_tmp_t:file read_file_perms;
+
+	files_search_pids($1)
+	allow $1 cron_var_run_t:file read_file_perms;
 ')
 
 ########################################
 ## <summary>
-##	Read and write inherited system cron
-##	job unix domain stream sockets.
+##	Do not audit attempts to append temporary
+##	files from the system cron jobs.
 ## </summary>
 ## <param name="domain">
 ##	<summary>
-##	Domain allowed access.
+##	Domain to not audit.
 ##	</summary>
 ## </param>
 #
-interface(`cron_rw_system_job_stream_sockets',`
+interface(`cron_dontaudit_append_system_job_tmp_files',`
 	gen_require(`
-		type system_cronjob_t;
+		type system_cronjob_tmp_t;
 	')
 
-	allow $1 system_cronjob_t:unix_stream_socket { read write };
+	dontaudit $1 system_cronjob_tmp_t:file append_file_perms;
 ')
 
 ########################################
 ## <summary>
-##	Read system cron job temporary files.
+##	Do not audit attempts to write temporary
+##	files from the system cron jobs.
 ## </summary>
 ## <param name="domain">
 ##	<summary>
-##	Domain allowed access.
+##	Domain to not audit.
 ##	</summary>
 ## </param>
 #
-interface(`cron_read_system_job_tmp_files',`
+interface(`cron_dontaudit_write_system_job_tmp_files',`
 	gen_require(`
 		type system_cronjob_tmp_t;
+		type cron_var_run_t;
 	')
 
-	files_search_tmp($1)
-	allow $1 system_cronjob_tmp_t:file read_file_perms;
+	dontaudit $1 system_cronjob_tmp_t:file write_file_perms;
+	dontaudit $1 cron_var_run_t:file write_file_perms;
 ')
 
 ########################################
 ## <summary>
-##	Do not audit attempts to append temporary
-##	system cron job files.
+##	Read temporary files from the system cron jobs.
 ## </summary>
 ## <param name="domain">
 ##	<summary>
-##	Domain to not audit.
+##	Domain allowed access.
 ##	</summary>
 ## </param>
 #
-interface(`cron_dontaudit_append_system_job_tmp_files',`
+interface(`cron_read_system_job_lib_files',`
 	gen_require(`
-		type system_cronjob_tmp_t;
+		type system_cronjob_var_lib_t;
 	')
 
-	dontaudit $1 system_cronjob_tmp_t:file append_file_perms;
+	files_search_var_lib($1)
+	read_files_pattern($1, system_cronjob_var_lib_t, system_cronjob_var_lib_t)
 ')
 
 ########################################
 ## <summary>
-##	Do not audit attempts to write temporary
-##	system cron job files.
+##	Manage files from the system cron jobs.
 ## </summary>
 ## <param name="domain">
 ##	<summary>
-##	Domain to not audit.
+##	Domain allowed access.
 ##	</summary>
 ## </param>
 #
-interface(`cron_dontaudit_write_system_job_tmp_files',`
+interface(`cron_manage_system_job_lib_files',`
 	gen_require(`
-		type system_cronjob_tmp_t;
+		type system_cronjob_var_lib_t;
 	')
 
-	dontaudit $1 system_cronjob_tmp_t:file write_file_perms;
+	files_search_var_lib($1)
+	manage_files_pattern($1, system_cronjob_var_lib_t, system_cronjob_var_lib_t)
+')
+
+#######################################
+## <summary>
+##  Create, read, write and delete
+##  cron log files.
+## </summary>
+## <param name="domain">
+##  <summary>
+##  Domain allowed access.
+##  </summary>
+## </param>
+#
+interface(`cron_manage_log_files',`
+    gen_require(`
+        type cron_log_t;
+    ')
+
+    manage_files_pattern($1, cron_log_t, cron_log_t)
+
+    logging_search_logs($1)
+')
+
+#######################################
+## <summary>
+##  Create specified objects in generic
+##  log directories with the cron log file type.
+## </summary>
+## <param name="domain">
+##  <summary>
+##  Domain allowed access.
+##  </summary>
+## </param>
+## <param name="object_class">
+##  <summary>
+##  Class of the object being created.
+##  </summary>
+## </param>
+## <param name="name" optional="true">
+##  <summary>
+##  The name of the object being created.
+##  </summary>
+## </param>
+#
+interface(`cron_generic_log_filetrans_log',`
+    gen_require(`
+        type cron_log_t;
+    ')
+
+    logging_log_filetrans($1, cron_log_t, $2, $3)
 ')
